searchData={"items":[{"type":"module","title":"JediHelpers","doc":"Documentation for `JediHelpers`.","ref":"JediHelpers.html"},{"type":"function","title":"JediHelpers.atom_to_readable_string/1","doc":"Converts an atom into a human-readable string by title-casing its segments.\n\nUseful for displaying labels or headings derived from atoms.","ref":"JediHelpers.html#atom_to_readable_string/1"},{"type":"function","title":"Examples - JediHelpers.atom_to_readable_string/1","doc":"iex> JediHelpers.atom_to_readable_string(:user_profile)\n    \"User Profile\"\n\n    iex> JediHelpers.atom_to_readable_string(:admin)\n    \"Admin\"","ref":"JediHelpers.html#atom_to_readable_string/1-examples"},{"type":"function","title":"JediHelpers.format_decimal/1","doc":"Formats a decimal or numeric input by:\n\n  - Converting it to a `Decimal`\n  - Rounding to 2 decimal places\n  - Converting to a string\n  - Adding thousands separators (e.g., `\"1,234.56\"`)\n\nReturns `nil` if the input is `nil`.","ref":"JediHelpers.html#format_decimal/1"},{"type":"function","title":"Examples - JediHelpers.format_decimal/1","doc":"iex> format_decimal(1234567.891)\n    \"1,234,567.89\"\n\n    iex> format_decimal(\"1000.1\")\n    \"1,000.10\"\n\n    iex> format_decimal(nil)\n    nil","ref":"JediHelpers.html#format_decimal/1-examples"},{"type":"function","title":"Requirements - JediHelpers.format_decimal/1","doc":"Requires the `:decimal` and `:number` libraries.","ref":"JediHelpers.html#format_decimal/1-requirements"},{"type":"function","title":"JediHelpers.format_name/1","doc":"Formats a user's full name as `\"First Last\"`.\n\nReturns `nil` if the input is `nil`.","ref":"JediHelpers.html#format_name/1"},{"type":"function","title":"Examples - JediHelpers.format_name/1","doc":"iex> format_name(%{first_name: \"Luke\", last_name: \"Skywalker\"})\n    \"Luke Skywalker\"","ref":"JediHelpers.html#format_name/1-examples"},{"type":"function","title":"JediHelpers.format_name/2","doc":"Formats a user's name as `\"Last, First\"` if `:last_first` style is passed.","ref":"JediHelpers.html#format_name/2"},{"type":"function","title":"Examples - JediHelpers.format_name/2","doc":"iex> format_name(%{first_name: \"Luke\", last_name: \"Skywalker\"}, :last_first)\n    \"Skywalker, Luke\"","ref":"JediHelpers.html#format_name/2-examples"},{"type":"function","title":"JediHelpers.format_name_with_email/1","doc":"Formats a user's full name with email as `\"First Last - email@example.com\"`.","ref":"JediHelpers.html#format_name_with_email/1"},{"type":"function","title":"Examples - JediHelpers.format_name_with_email/1","doc":"iex> format_name_with_email(%{first_name: \"Leia\", last_name: \"Organa\", email: \"leia@alderaan.com\"})\n    \"Leia Organa - leia@alderaan.com\"","ref":"JediHelpers.html#format_name_with_email/1-examples"},{"type":"function","title":"JediHelpers.resource_type/1","doc":"Returns the underscored (snake_case) name of a struct's module as a string.\n\nUseful for generating type identifiers from structs, especially in APIs or dynamic logic.","ref":"JediHelpers.html#resource_type/1"},{"type":"function","title":"Example - JediHelpers.resource_type/1","doc":"iex> resource_type(%JediHelpers.BlogPost{})\n    \"blog_post\"","ref":"JediHelpers.html#resource_type/1-example"},{"type":"function","title":"Parameters: - JediHelpers.resource_type/1","doc":"- `resource` (`struct`): Any Elixir struct.","ref":"JediHelpers.html#resource_type/1-parameters"},{"type":"function","title":"Returns: - JediHelpers.resource_type/1","doc":"- `String.t()`: The snake_case name of the struct's module (last segment only).","ref":"JediHelpers.html#resource_type/1-returns"},{"type":"function","title":"JediHelpers.uri_parse_path/1","doc":"Extracts the path segment from a URI string.\n\nUseful for isolating the path portion of a full URL (e.g. `/users/123`).","ref":"JediHelpers.html#uri_parse_path/1"},{"type":"function","title":"Example - JediHelpers.uri_parse_path/1","doc":"iex> uri_parse_path(\"https://example.com/users/123?ref=home\")\n    \"/users/123\"","ref":"JediHelpers.html#uri_parse_path/1-example"},{"type":"function","title":"Parameters: - JediHelpers.uri_parse_path/1","doc":"- `uri` (`String.t()`): A URI string.","ref":"JediHelpers.html#uri_parse_path/1-parameters"},{"type":"function","title":"Returns: - JediHelpers.uri_parse_path/1","doc":"- `String.t()` or `nil`: The path component of the URI, or `nil` if absent.","ref":"JediHelpers.html#uri_parse_path/1-returns"},{"type":"module","title":"JediHelpers.ChangesetHelpers","doc":"","ref":"JediHelpers.ChangesetHelpers.html"},{"type":"function","title":"JediHelpers.ChangesetHelpers.trim_whitespace/3","doc":"Trims leading and trailing whitespaces from the specified fields in the changeset.\nThis ensures consistency and helps maintain uniqueness, especially for `citext` fields.\n\nYou can also specify a `max` length in the `opts` to validate that the field's length\nafter trimming does not exceed the specified value. If it exceeds, a validation error is added.","ref":"JediHelpers.ChangesetHelpers.html#trim_whitespace/3"},{"type":"function","title":"Example - JediHelpers.ChangesetHelpers.trim_whitespace/3","doc":"changeset\n|> trim_whitespace(:username, max: 50)\n|> unique_constraint(:username)","ref":"JediHelpers.ChangesetHelpers.html#trim_whitespace/3-example"},{"type":"function","title":"Parameters: - JediHelpers.ChangesetHelpers.trim_whitespace/3","doc":"- `changeset` (`Ecto.Changeset.t()`): The changeset containing the field to be processed.\n- `field` (`atom()` or `[atom()]`): The field(s) to trim.\n- `opts` (`keyword()`): Options for the function:\n- `:max` (`integer()`): The maximum allowed length after trimming. Adds a validation error if exceeded.","ref":"JediHelpers.ChangesetHelpers.html#trim_whitespace/3-parameters"},{"type":"function","title":"Returns: - JediHelpers.ChangesetHelpers.trim_whitespace/3","doc":"- An updated `Ecto.Changeset.t()` with the trimmed field and potential validation error if the length exceeds `max`.","ref":"JediHelpers.ChangesetHelpers.html#trim_whitespace/3-returns"},{"type":"module","title":"JediHelpers.FormHelpers","doc":"Helper functions for form inputs and options.","ref":"JediHelpers.FormHelpers.html"},{"type":"function","title":"JediHelpers.FormHelpers.options_for/2","doc":"Generates `{label, id}` tuples for a list of maps or structs to be used in dropdowns.","ref":"JediHelpers.FormHelpers.html#options_for/2"},{"type":"function","title":"Examples - JediHelpers.FormHelpers.options_for/2","doc":"iex> users = [%{id: 1, name: \"Alice\"}, %{id: 2, name: \"Bob\"}]\n    iex> JediHelpers.FormHelpers.options_for(users, :name)\n    [{\"Alice\", 1}, {\"Bob\", 2}]\n\nRaises if an element is not a map or struct, or if the arguments are invalid.","ref":"JediHelpers.FormHelpers.html#options_for/2-examples"},{"type":"extras","title":"JediHelpers","doc":"# JediHelpers\n\nA collection of general-purpose helpers for Elixir projects, designed to make your codebase cleaner and more reusable. Includes utilities for working with changesets and common functional patterns.","ref":"readme.html"},{"type":"extras","title":"Features - JediHelpers","doc":"- `JediHelpers.ChangesetHelpers.trim_whitespace/2` – trims leading and trailing whitespace from string fields in Ecto changesets.\n- Other helper functions coming soon.","ref":"readme.html#features"},{"type":"extras","title":"Installation - JediHelpers","doc":"Add `:jedi_helpers` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:jedi_helpers, \"~> 0.1.0\"}\n  ]\nend\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"readme.html#installation"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\n## [0.1.1] - 2025-05-09","ref":"changelog.html"},{"type":"extras","title":"Added - Changelog","doc":"- `format_decimal/1` to format decimals with commas and 2 decimal places.\n- `format_name/1` and `format_name/2` for flexible user name formatting.\n- `format_name_with_email/1` for full name + email formatting.\n\n## [0.1.0] - 2025-05-06","ref":"changelog.html#added"},{"type":"extras","title":"Added - Changelog","doc":"- Initial release with Changeset Helpers,  FormHelpers, and other utility functions.","ref":"changelog.html#added"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}